#include <owl\pch.h>
#pragma hdrstop
//#include <owl\applicat.h>
//#include <owl\framewin.h>
//#include <owl\gdiobjec.h>
//#include <owl\dc.h>
//#include <owl\color.h>
#include "256bgrnd.rh"

#define COLORSIZE 256


class TWndw : public TFrameWindow {
public:
	TWndw(TWindow *parent, const char far *title);
	~TWndw();
protected:
	void SetupWindow();
	void CleanupWindow();
	bool EvEraseBkgnd(HDC hDC);
	void EvSize(UINT sizeType, TSize& size);
private:
	TPalette* palette;
DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1(TWndw, TFrameWindow)
	EV_WM_ERASEBKGND,
	EV_WM_SIZE,
END_RESPONSE_TABLE;


TWndw::TWndw(TWindow *parent, const char far *title)
	:	TFrameWindow(parent, title)
{
	AssignMenu(MENU_1);

	TPaletteEntry* palEntries;
	palEntries = (TPaletteEntry*)new char[sizeof(TPaletteEntry) * COLORSIZE];

	for (int i = 0; i < COLORSIZE; i++) {
		palEntries[i].peRed = 0;
		palEntries[i].peGreen = 0;
		palEntries[i].peBlue = COLORSIZE - i - 1;
		palEntries[i].peFlags = PC_RESERVED;
	}

	palette = new TPalette(palEntries, COLORSIZE);
	delete[] palEntries;
}


TWndw::~TWndw()
{
	delete palette;
}


void TWndw::SetupWindow()
{
	TFrameWindow::SetupWindow();
}


void TWndw::CleanupWindow()
{
}


void TWndw::EvSize(uint sizeType, TSize& size)
{
	TFrameWindow::EvSize(sizeType, size);
	Invalidate();
	UpdateWindow();
}


bool TWndw::EvEraseBkgnd(HDC hDC)
{
	TDC dc(hDC);
	dc.SelectObject(*palette);
	dc.RealizePalette();

	TRect clientRect = GetClientRect();
	TRect rcFill(0, 0, clientRect.right,
	MulDiv(1, clientRect.bottom, COLORSIZE));

	for (int i = 0; i < COLORSIZE; i++) {
		dc.FillRect(rcFill, TBrush(TColor(i), false));
		rcFill.top = rcFill.bottom;
		rcFill.bottom = MulDiv(i + 2, clientRect.bottom, COLORSIZE);
	}
	dc.RestorePalette();
	return true;
}

///////////////////////////////////////////////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};


void TApp::InitMainWindow()
{
	TFrameWindow *wndw = new TWndw(0, "256-color Background");
	SetMainWindow(wndw);
	nCmdShow=SW_SHOWMAXIMIZED;
}


int OwlMain(int, char*[])
{
	return TApp().Run();
}

